// template/newFeatures/newFeatures.js
var app = getApp()
var config = {};
var miucms = require('../../utils/miucms.js');
var WxParse = require('../../wxParse/wxParse.js');
Component({
  /**
   * 组件的属性列表
   */
  properties: {

  },

  /**
   * 组件的初始数据
   */
  data: {
    newFunction: false
  },
  lifetimes: {
    attached: function () {
      this.attachedIn()
    },
  },
  attached: function () {
    this.attachedIn()
  },
  /**
   * 组件的方法列表
   */
  timer: null,
  methods: {
    attachedIn() {
      this.getContent()
    },
    getContent() {
      var that = this;
      clearTimeout(that.timer)
      if (!app.globalData.config.lists) {
        this.timer = setTimeout(function () {
          that.getContent()
        }, 500)
        return false
      }
      // console.log(app.globalData['notice']);

      // app.globalData['notice'] = {
      //   title: '标题',
      //   message: '111'
      // }

      this.setData({
        newFunction: app.globalData.notice
      })
      if (app.globalData.notice && app.globalData.notice !== false) {
        WxParse.wxParse('newFunction.message', 'html', '<div>' + app.globalData.notice.message + '</div>', this, 0);
      }
      app.globalData.notice = false;
    },
    // 关闭弹窗
    close_newFunction: function () {
      this.data.newFunction = false;
      this.setData({
        newFunction: this.data.newFunction
      })
      app.globalData.notice = false;
    },
  }
})