// template/selectSingle/selectSingle.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    title:String,
    list:Array,
    value:String,
    formSelect: Boolean,//是否用在发布表格中
    slots:Boolean,//是否有slot对象
  },

  /**
   * 组件的初始数据
   */
  data: {
    name:'最新发布',
    show:false,
    name2:''
  },
  observers: {
    "value":function(e) {
      // if(!this.properties.formSelect){
        for(var i =0;i<this.properties.list.length;i++){
          if (this.properties.list[i].value == e){
            this.setData({
              name: this.properties.list[i].name,
              name2: this.properties.list[i].name,
            })
            break;
          }
        }
      // }
    },
  },
  /**
   * 组件的方法列表
   */
  methods: {
    catchmove() { },
    changeItem(e){
      let { name, value, alias } = e.currentTarget.dataset;
      this.setData({
        show:false,
        name,
        name2:name
      })
      this.triggerEvent('submit', { value, name, alias })
    },
    showAlert(e){      
      this.setData({
        show: e.currentTarget.dataset.show ==1 ? true :false
      })
    }
  }
})
