// template/aboutRelease/aboutRelease.js
Component({
    /**
     * 组件的属性列表
     */
    properties: {
        aboutRulesList: Object,
    },

    /**
     * 组件的初始数据
     */
    data: {
        tab: "person", // person 个人  intermediary 中介  more 更多
        navList: [{
            name: "个人账号",
            type: "person"
        }, {
            name: "中介账号",
            type: "intermediary"
        }, {
            name: "更多说明",
            type: "more"
        }]
    },

    /**
     * 组件的方法列表
     */
    methods: {
        // 切换nav
        switchingNav(e) {
            let type = e.currentTarget.dataset.type
            this.setData({
                tab: type
            })
        },

        // 关闭弹窗
        closePop(e) {
            this.triggerEvent('setValue', e)
        },

    }
})